diff -rupN keepalived-1.2.7/goodies/arpreset.pl keepalived-1.2.7-unicast/goodies/arpreset.pl
--- keepalived-1.2.7/goodies/arpreset.pl	1970-01-01 01:00:00.000000000 +0100
+++ keepalived-1.2.7-unicast/goodies/arpreset.pl	2013-05-24 10:12:36.495160800 +0200
@@ -0,0 +1,97 @@
+#!/usr/bin/perl -w
+
+###################################################################
+# arpreset 0.2
+# Copyright (C) 2005  Steve Milton (milton AT isomedia.com)
+#
+# Utility for deleting a single ARP entry from a cisco router.
+# Script adapted from description on Cisco tech article.
+#   http://www.cisco.com/warp/public/477/SNMP/clear_arp.shtml
+#
+# The Cisco router needs to have a read/write community setup
+# for the utility to work.  I recommend using the following
+# IOS commands to setup a restricted community that can only
+# work with the MAC table.  You will need ENABLE level access
+# to the router to execute these commands.
+#
+#    access-list 50 permit 123.123.123.123
+#    access-list 50 permit 123.123.123.124
+#    access-list 50 deny any
+#    snmp-server view arpchange ipNetToMediaEntry.4 included
+#    snmp-server community blahblah view arpchange RW 50
+#
+# Set the access-list permit to the IP addresses of the systems
+# you want to be able to make changes to the MAC table.  Set 
+# the community name (above blahblah) to something random and 
+# password-like.
+###################################################################
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License
+# as published by the Free Software Foundation; either version 2
+# of the License, or (at your option) any later version.
+# 
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+# 
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  
+# 02110-1301, USA.
+###################################################################
+
+use strict;
+use Getopt::Long;
+&Getopt::Long::config('auto_abbrev');
+
+my ($router,$community,$address,$help,$check);
+$router=$community=$address=$help=$check="";
+
+my $status = GetOptions("router:s" => \$router,
+                        "community:s" => \$community,
+                        "address:s" => \$address,
+			"help" => \$help,
+			"check" => \$check);
+
+if (($status == 0) or $help) {
+    &PrintUsage;
+    exit 1;
+}
+
+if (!$router or !$community or !$address) {
+    &PrintUsage;
+    exit 1;
+}
+
+# OID for the ARP table entries
+my $ciscoOID = ".1.3.6.1.2.1.4.22.1.4";
+my $target = "";
+
+# Walk the SNMP ARP table on the router to locate the target address
+open(GET, "/usr/bin/snmpwalk -v1 -c $community $router $ciscoOID |");
+while(<GET>) {
+    if (/^(.*?\.$address)\s/) {
+	$target = $1;
+	print $_;
+    }
+}
+close(GET);
+if ($target and !$check) {
+    print "-- changed to --\n";
+    # set the target address to "invalid"
+    system("/usr/bin/snmpset -v1 -c $community $router $target i 2");
+} elsif (!$check) {
+    print "No target OID located.";
+    exit 1;
+}
+exit;
+
+sub PrintUsage {
+    print "arpreset 0.2\nCopyright (c) 2005 by Steve Milton\narpreset comes with ABSOLUTELY NO WARRANTY\n\n";
+    print "Usage: arpreset --router=routeraddress --community=rwcommunity --address=ipaddress\n";
+    print "       arpreset --help\n";
+    print "\nWhere ipaddress is the IP address in the Cisco router that you want to invalidate\nfrom the MAC address cache.\n";
+    print "\nYou can add --check to the command to make it NOT update the router, but check for\nthe entry only.\n";
+    exit;
+}
diff -rupN keepalived-1.2.7/keepalived/check/check_api.c keepalived-1.2.7-unicast/keepalived/check/check_api.c
--- keepalived-1.2.7/keepalived/check/check_api.c	2012-08-13 20:50:25.000000000 +0200
+++ keepalived-1.2.7-unicast/keepalived/check/check_api.c	2013-05-24 10:12:36.502161200 +0200
@@ -64,8 +64,8 @@ queue_checker(void (*free_func) (void *)
 	      , int (*launch) (thread_t *)
 	      , void *data)
 {
-	virtual_server *vs = LIST_TAIL_DATA(check_data->vs);
-	real_server *rs = LIST_TAIL_DATA(vs->rs);
+	virtual_server_t *vs = LIST_TAIL_DATA(check_data->vs);
+	real_server_t *rs = LIST_TAIL_DATA(vs->rs);
 	checker_t *checker = (checker_t *) MALLOC(sizeof (checker_t));
 
 	checker->free_func = free_func;
@@ -96,8 +96,8 @@ queue_checker(void (*free_func) (void *)
 void
 checker_set_dst(struct sockaddr_storage *dst)
 {
-	virtual_server *vs = LIST_TAIL_DATA(check_data->vs);
-	real_server *rs = LIST_TAIL_DATA(vs->rs);
+	virtual_server_t *vs = LIST_TAIL_DATA(check_data->vs);
+	real_server_t *rs = LIST_TAIL_DATA(vs->rs);
 
 	*dst = rs->addr;
 }
diff -rupN keepalived-1.2.7/keepalived/check/check_data.c keepalived-1.2.7-unicast/keepalived/check/check_data.c
--- keepalived-1.2.7/keepalived/check/check_data.c	2012-08-29 00:05:12.000000000 +0200
+++ keepalived-1.2.7-unicast/keepalived/check/check_data.c	2013-05-24 10:12:36.505161300 +0200
@@ -29,8 +29,8 @@
 #include "ipwrapper.h"
 
 /* global vars */
-check_conf_data *check_data = NULL;
-check_conf_data *old_check_data = NULL;
+check_data_t *check_data = NULL;
+check_data_t *old_check_data = NULL;
 
 /* SSL facility functions */
 ssl_data_t *
@@ -73,7 +73,7 @@ dump_ssl(void)
 static void
 free_vsg(void *data)
 {
-	virtual_server_group *vsg = data;
+	virtual_server_group_t *vsg = data;
 	FREE_PTR(vsg->gname);
 	free_list(vsg->addr_ip);
 	free_list(vsg->range);
@@ -83,7 +83,7 @@ free_vsg(void *data)
 static void
 dump_vsg(void *data)
 {
-	virtual_server_group *vsg = data;
+	virtual_server_group_t *vsg = data;
 
 	log_message(LOG_INFO, " Virtual Server Group = %s", vsg->gname);
 	dump_list(vsg->addr_ip);
@@ -98,7 +98,7 @@ free_vsg_entry(void *data)
 static void
 dump_vsg_entry(void *data)
 {
-	virtual_server_group_entry *vsg_entry = data;
+	virtual_server_group_entry_t *vsg_entry = data;
 
 	if (vsg_entry->vfwmark)
 		log_message(LOG_INFO, "   FWMARK = %d", vsg_entry->vfwmark);
@@ -116,9 +116,9 @@ void
 alloc_vsg(char *gname)
 {
 	int size = strlen(gname);
-	virtual_server_group *new;
+	virtual_server_group_t *new;
 
-	new = (virtual_server_group *) MALLOC(sizeof (virtual_server_group));
+	new = (virtual_server_group_t *) MALLOC(sizeof(virtual_server_group_t));
 	new->gname = (char *) MALLOC(size + 1);
 	memcpy(new->gname, gname, size);
 	new->addr_ip = alloc_list(free_vsg_entry, dump_vsg_entry);
@@ -130,10 +130,10 @@ alloc_vsg(char *gname)
 void
 alloc_vsg_entry(vector_t *strvec)
 {
-	virtual_server_group *vsg = LIST_TAIL_DATA(check_data->vs_group);
-	virtual_server_group_entry *new;
+	virtual_server_group_t *vsg = LIST_TAIL_DATA(check_data->vs_group);
+	virtual_server_group_entry_t *new;
 
-	new = (virtual_server_group_entry *) MALLOC(sizeof (virtual_server_group_entry));
+	new = (virtual_server_group_entry_t *) MALLOC(sizeof(virtual_server_group_entry_t));
 
 	if (!strcmp(vector_slot(strvec, 0), "fwmark")) {
 		new->vfwmark = atoi(vector_slot(strvec, 1));
@@ -152,7 +152,7 @@ alloc_vsg_entry(vector_t *strvec)
 static void
 free_vs(void *data)
 {
-	virtual_server *vs = data;
+	virtual_server_t *vs = data;
 	FREE_PTR(vs->vsgname);
 	FREE_PTR(vs->virtualhost);
 	FREE_PTR(vs->s_svr);
@@ -164,7 +164,7 @@ free_vs(void *data)
 static void
 dump_vs(void *data)
 {
-	virtual_server *vs = data;
+	virtual_server_t *vs = data;
 
 	if (vs->vsgname)
 		log_message(LOG_INFO, " VS GROUP = %s", vs->vsgname);
@@ -226,9 +226,9 @@ void
 alloc_vs(char *ip, char *port)
 {
 	int size = strlen(port);
-	virtual_server *new;
+	virtual_server_t *new;
 
-	new = (virtual_server *) MALLOC(sizeof (virtual_server));
+	new = (virtual_server_t *) MALLOC(sizeof(virtual_server_t));
 
 	if (!strcmp(ip, "group")) {
 		new->vsgname = (char *) MALLOC(size + 1);
@@ -257,9 +257,9 @@ alloc_vs(char *ip, char *port)
 void
 alloc_ssvr(char *ip, char *port)
 {
-	virtual_server *vs = LIST_TAIL_DATA(check_data->vs);
+	virtual_server_t *vs = LIST_TAIL_DATA(check_data->vs);
 
-	vs->s_svr = (real_server *) MALLOC(sizeof (real_server));
+	vs->s_svr = (real_server_t *) MALLOC(sizeof(real_server_t));
 	vs->s_svr->weight = 1;
 	vs->s_svr->iweight = 1;
 	inet_stosockaddr(ip, port, &vs->s_svr->addr);
@@ -269,7 +269,7 @@ alloc_ssvr(char *ip, char *port)
 static void
 free_rs(void *data)
 {
-	real_server *rs = data;
+	real_server_t *rs = data;
 	FREE_PTR(rs->notify_up);
 	FREE_PTR(rs->notify_down);
 	free_list(rs->failed_checkers);
@@ -278,7 +278,7 @@ free_rs(void *data)
 static void
 dump_rs(void *data)
 {
-	real_server *rs = data;
+	real_server_t *rs = data;
 
 	log_message(LOG_INFO, "   RIP = %s, RPORT = %d, WEIGHT = %d"
 			    , inet_sockaddrtos(&rs->addr)
@@ -303,10 +303,10 @@ free_failed_checkers(void *data)
 void
 alloc_rs(char *ip, char *port)
 {
-	virtual_server *vs = LIST_TAIL_DATA(check_data->vs);
-	real_server *new;
+	virtual_server_t *vs = LIST_TAIL_DATA(check_data->vs);
+	real_server_t *new;
 
-	new = (real_server *) MALLOC(sizeof (real_server));
+	new = (real_server_t *) MALLOC(sizeof(real_server_t));
 	inet_stosockaddr(ip, port, &new->addr);
 
 	new->weight = 1;
@@ -319,12 +319,12 @@ alloc_rs(char *ip, char *port)
 }
 
 /* data facility functions */
-check_conf_data *
+check_data_t *
 alloc_check_data(void)
 {
-	check_conf_data *new;
+	check_data_t *new;
 
-	new = (check_conf_data *) MALLOC(sizeof (check_conf_data));
+	new = (check_data_t *) MALLOC(sizeof(check_data_t));
 	new->vs = alloc_list(free_vs, dump_vs);
 	new->vs_group = alloc_list(free_vsg, dump_vsg);
 
@@ -332,7 +332,7 @@ alloc_check_data(void)
 }
 
 void
-free_check_data(check_conf_data *data)
+free_check_data(check_data_t *data)
 {
 	free_list(data->vs);
 	free_list(data->vs_group);
@@ -340,7 +340,7 @@ free_check_data(check_conf_data *data)
 }
 
 void
-dump_check_data(check_conf_data *data)
+dump_check_data(check_data_t *data)
 {
 	if (data->ssl) {
 		log_message(LOG_INFO, "------< SSL definitions >------");
diff -rupN keepalived-1.2.7/keepalived/check/check_http.c keepalived-1.2.7-unicast/keepalived/check/check_http.c
--- keepalived-1.2.7/keepalived/check/check_http.c	2012-08-29 00:05:12.000000000 +0200
+++ keepalived-1.2.7-unicast/keepalived/check/check_http.c	2013-05-24 10:12:36.507161400 +0200
@@ -92,7 +92,7 @@ alloc_http_get(char *proto)
 	http_checker_t *http_get_chk;
 
 	http_get_chk = (http_checker_t *) MALLOC(sizeof (http_checker_t));
-	http_get_chk->arg = (http_arg_t *) MALLOC(sizeof (http_arg_t));
+	http_get_chk->arg = (http_t *) MALLOC(sizeof (http_t));
 	http_get_chk->proto =
 	    (!strcmp(proto, "HTTP_GET")) ? PROTO_HTTP : PROTO_SSL;
 	http_get_chk->url = alloc_list(free_url, dump_url);
@@ -270,13 +270,13 @@ epilog(thread_t * thread, int method, in
 {
 	checker_t *checker = THREAD_ARG(thread);
 	http_checker_t *http_get_check = CHECKER_ARG(checker);
-	http_arg_t *http_arg = HTTP_ARG(http_get_check);
-	request_t *req = HTTP_REQ(http_arg);
+	http_t *http = HTTP_ARG(http_get_check);
+	request_t *req = HTTP_REQ(http);
 	long delay = 0;
 
 	if (method) {
-		http_arg->url_it += t ? t : -http_arg->url_it;
-		http_arg->retry_it += c ? c : -http_arg->retry_it;
+		http->url_it += t ? t : -http->url_it;
+		http->retry_it += c ? c : -http->retry_it;
 	}
 
 	/*
@@ -285,11 +285,11 @@ epilog(thread_t * thread, int method, in
 	 * html buffer. This is sometime needed with some applications
 	 * servers.
 	 */
-	if (http_arg->retry_it > http_get_check->nb_get_retry-1) {
+	if (http->retry_it > http_get_check->nb_get_retry-1) {
 		if (svr_checker_up(checker->id, checker->rs)) {
 			log_message(LOG_INFO, "Check on service [%s]:%d failed after %d retry."
 			       , inet_sockaddrtos(&http_get_check->dst)
-			       , ntohs(inet_sockaddrport(&http_get_check->dst)), http_arg->retry_it);
+			       , ntohs(inet_sockaddrport(&http_get_check->dst)), http->retry_it);
 			smtp_alert(checker->rs, NULL, NULL,
 				   "DOWN",
 				   "=> CHECK failed on service"
@@ -300,8 +300,8 @@ epilog(thread_t * thread, int method, in
 		}
 
 		/* Reset it counters */
-		http_arg->url_it = 0;
-		http_arg->retry_it = 0;
+		http->url_it = 0;
+		http->retry_it = 0;
 	}
 
 	/* register next timer thread */
@@ -314,7 +314,7 @@ epilog(thread_t * thread, int method, in
 			    http_get_check->delay_before_retry;
 		break;
 	case 2:
-		if (http_arg->url_it == 0 && http_arg->retry_it == 0)
+		if (http->url_it == 0 && http->retry_it == 0)
 			delay = checker->vs->delay_loop;
 		else
 			delay = http_get_check->delay_before_retry;
@@ -328,7 +328,7 @@ epilog(thread_t * thread, int method, in
 		if (req->buffer)
 			FREE(req->buffer);
 		FREE(req);
-		http_arg->req = NULL;
+		http->req = NULL;
 		close(thread->u.fd);
 	}
 
@@ -364,9 +364,9 @@ timeout_epilog(thread_t * thread, char *
 url_t *
 fetch_next_url(http_checker_t * http_get_check)
 {
-	http_arg_t *http_arg = HTTP_ARG(http_get_check);
+	http_t *http = HTTP_ARG(http_get_check);
 
-	return list_element(http_get_check->url, http_arg->url_it);
+	return list_element(http_get_check->url, http->url_it);
 }
 
 /* Handle response */
@@ -376,8 +376,8 @@ http_handle_response(thread_t * thread,
 {
 	checker_t *checker = THREAD_ARG(thread);
 	http_checker_t *http_get_check = CHECKER_ARG(checker);
-	http_arg_t *http_arg = HTTP_ARG(http_get_check);
-	request_t *req = HTTP_REQ(http_arg);
+	http_t *http = HTTP_ARG(http_get_check);
+	request_t *req = HTTP_REQ(http);
 	int r, di = 0;
 	char *digest_tmp;
 	url_t *fetched_url = fetch_next_url(http_get_check);
@@ -411,13 +411,13 @@ http_handle_response(thread_t * thread,
 				DBG("HTTP Status_code to [%s]:%d url(%d) = [%d]."
 				    , inet_sockaddrtos(&http_get_check->dst)
 				    , ntohs(inet_sockaddrport(&http_get_check->dst))
-				    , http_arg->url_it + 1
+				    , http->url_it + 1
 				    , req->status_code);
 				/*
 				 * We set retry iterator to max value to not retry
 				 * when service is already know as die.
 				 */
-				http_arg->retry_it = http_get_check->nb_get_retry;
+				http->retry_it = http_get_check->nb_get_retry;
 			}
 			return epilog(thread, 2, 0, 1);
 		} else {
@@ -426,7 +426,7 @@ http_handle_response(thread_t * thread,
 				       "HTTP status code success to [%s]:%d url(%d)."
 				       , inet_sockaddrtos(&http_get_check->dst)
 				       , ntohs(inet_sockaddrport(&http_get_check->dst))
-				       , http_arg->url_it + 1);
+				       , http->url_it + 1);
 			return epilog(thread, 1, 1, 0) + 1;
 		}
 	}
@@ -461,13 +461,13 @@ http_handle_response(thread_t * thread,
 				DBG("MD5SUM to [%s]:%d url(%d) = [%s]."
 				    , inet_sockaddrtos(&http_get_check->dst)
 				    , ntohs(inet_sockaddrport(&http_get_check->dst))
-				    , http_arg->url_it + 1
+				    , http->url_it + 1
 				    , digest_tmp);
 				/*
 				 * We set retry iterator to max value to not retry
 				 * when service is already know as die.
 				 */
-				http_arg->retry_it = http_get_check->nb_get_retry;
+				http->retry_it = http_get_check->nb_get_retry;
 			}
 			FREE(digest_tmp);
 			return epilog(thread, 2, 0, 1);
@@ -476,7 +476,7 @@ http_handle_response(thread_t * thread,
 				log_message(LOG_INFO, "MD5 digest success to [%s]:%d url(%d)."
 				       , inet_sockaddrtos(&http_get_check->dst)
 				       , ntohs(inet_sockaddrport(&http_get_check->dst))
-				       , http_arg->url_it + 1);
+				       , http->url_it + 1);
 			FREE(digest_tmp);
 			return epilog(thread, 1, 1, 0) + 1;
 		}
@@ -517,8 +517,8 @@ http_read_thread(thread_t * thread)
 {
 	checker_t *checker = THREAD_ARG(thread);
 	http_checker_t *http_get_check = CHECKER_ARG(checker);
-	http_arg_t *http_arg = HTTP_ARG(http_get_check);
-	request_t *req = HTTP_REQ(http_arg);
+	http_t *http = HTTP_ARG(http_get_check);
+	request_t *req = HTTP_REQ(http);
 	unsigned char digest[16];
 	int r = 0;
 	int val;
@@ -601,8 +601,8 @@ http_response_thread(thread_t * thread)
 {
 	checker_t *checker = THREAD_ARG(thread);
 	http_checker_t *http_get_check = CHECKER_ARG(checker);
-	http_arg_t *http_arg = HTTP_ARG(http_get_check);
-	request_t *req = HTTP_REQ(http_arg);
+	http_t *http = HTTP_ARG(http_get_check);
+	request_t *req = HTTP_REQ(http);
 
 	/* Handle read timeout */
 	if (thread->type == THREAD_READ_TIMEOUT)
@@ -632,8 +632,8 @@ http_request_thread(thread_t * thread)
 {
 	checker_t *checker = THREAD_ARG(thread);
 	http_checker_t *http_get_check = CHECKER_ARG(checker);
-	http_arg_t *http_arg = HTTP_ARG(http_get_check);
-	request_t *req = HTTP_REQ(http_arg);
+	http_t *http = HTTP_ARG(http_get_check);
+	request_t *req = HTTP_REQ(http);
 	char *vhost = CHECKER_VHOST(checker);
 	char *str_request;
 	url_t *fetched_url;
@@ -655,7 +655,7 @@ http_request_thread(thread_t * thread)
 		 (vhost) ? vhost : inet_sockaddrtos(&http_get_check->dst)
 		 , ntohs(inet_sockaddrport(&http_get_check->dst)));
 	DBG("Processing url(%d) of [%s]:%d.",
-	    http_arg->url_it + 1
+	    http->url_it + 1
 	    , inet_sockaddrtos(&http_get_check->dst)
 	    , ntohs(inet_sockaddrport(&http_get_check->dst)));
 
@@ -707,9 +707,9 @@ http_check_thread(thread_t * thread)
 {
 	checker_t *checker = THREAD_ARG(thread);
 	http_checker_t *http_get_check = CHECKER_ARG(checker);
-	http_arg_t *http_arg = HTTP_ARG(http_get_check);
+	http_t *http = HTTP_ARG(http_get_check);
 #ifdef _DEBUG_
-	request_t *req = HTTP_REQ(http_arg);
+	request_t *req = HTTP_REQ(http);
 #endif
 	int ret = 1;
 	int status;
@@ -743,8 +743,8 @@ http_check_thread(thread_t * thread)
 		break;
 
 	case connect_success:{
-			if (!http_arg->req) {
-				http_arg->req = (request_t *) MALLOC(sizeof (request_t));
+			if (!http->req) {
+				http->req = (request_t *) MALLOC(sizeof (request_t));
 				new_req = 1;
 			} else
 				new_req = 0;
@@ -761,7 +761,7 @@ http_check_thread(thread_t * thread)
 				}
 
 				if (ret == -1) {
-					switch ((ssl_err = SSL_get_error(http_arg->req->ssl,
+					switch ((ssl_err = SSL_get_error(http->req->ssl,
 									 ret))) {
 					case SSL_ERROR_WANT_READ:
 						thread_add_read(thread->master,
@@ -810,7 +810,7 @@ http_check_thread(thread_t * thread)
 					log_message(LOG_INFO, "SSL handshake/communication error"
 							 " connecting to server"
 							 " (openssl errno: %d) [%s]:%d."
-						       , SSL_get_error (http_arg->req->ssl, ret)
+						       , SSL_get_error (http->req->ssl, ret)
 						       , inet_sockaddrtos(&http_get_check->dst)
 						       , ntohs(inet_sockaddrport(&http_get_check->dst)));
 					smtp_alert(checker->rs, NULL, NULL,
@@ -836,7 +836,7 @@ http_connect_thread(thread_t * thread)
 {
 	checker_t *checker = THREAD_ARG(thread);
 	http_checker_t *http_get_check = CHECKER_ARG(checker);
-	http_arg_t *http_arg = HTTP_ARG(http_get_check);
+	http_t *http = HTTP_ARG(http_get_check);
 	url_t *fetched_url;
 	enum connect_result status;
 	int fd;
@@ -869,7 +869,7 @@ http_connect_thread(thread_t * thread)
 						   , checker->vs
 						   , checker->rs);
 		}
-		http_arg->req = NULL;
+		http->req = NULL;
 		return epilog(thread, 1, 0, 0) + 1;
 	}
 
diff -rupN keepalived-1.2.7/keepalived/check/check_parser.c keepalived-1.2.7-unicast/keepalived/check/check_parser.c
--- keepalived-1.2.7/keepalived/check/check_parser.c	2012-08-29 00:05:12.000000000 +0200
+++ keepalived-1.2.7-unicast/keepalived/check/check_parser.c	2013-05-24 10:12:36.510161600 +0200
@@ -76,7 +76,7 @@ vs_handler(vector_t *strvec)
 static void
 delay_handler(vector_t *strvec)
 {
-	virtual_server *vs = LIST_TAIL_DATA(check_data->vs);
+	virtual_server_t *vs = LIST_TAIL_DATA(check_data->vs);
 	vs->delay_loop = atoi(vector_slot(strvec, 1)) * TIMER_HZ;
 	if (vs->delay_loop < TIMER_HZ)
 		vs->delay_loop = TIMER_HZ;
@@ -84,7 +84,7 @@ delay_handler(vector_t *strvec)
 static void
 lbalgo_handler(vector_t *strvec)
 {
-	virtual_server *vs = LIST_TAIL_DATA(check_data->vs);
+	virtual_server_t *vs = LIST_TAIL_DATA(check_data->vs);
 	char *str = vector_slot(strvec, 1);
 	int size = sizeof (vs->sched);
 	int str_len = strlen(str);
@@ -97,7 +97,7 @@ lbalgo_handler(vector_t *strvec)
 static void
 lbkind_handler(vector_t *strvec)
 {
-	virtual_server *vs = LIST_TAIL_DATA(check_data->vs);
+	virtual_server_t *vs = LIST_TAIL_DATA(check_data->vs);
 	char *str = vector_slot(strvec, 1);
 
 	if (!strcmp(str, "NAT"))
@@ -112,13 +112,13 @@ lbkind_handler(vector_t *strvec)
 static void
 natmask_handler(vector_t *strvec)
 {
-	virtual_server *vs = LIST_TAIL_DATA(check_data->vs);
+	virtual_server_t *vs = LIST_TAIL_DATA(check_data->vs);
 	inet_ston(vector_slot(strvec, 1), &vs->nat_mask);
 }
 static void
 pto_handler(vector_t *strvec)
 {
-	virtual_server *vs = LIST_TAIL_DATA(check_data->vs);
+	virtual_server_t *vs = LIST_TAIL_DATA(check_data->vs);
 	char *str = vector_slot(strvec, 1);
 	int size = sizeof (vs->timeout_persistence);
 	int str_len = strlen(str);
@@ -131,7 +131,7 @@ pto_handler(vector_t *strvec)
 static void
 pgr_handler(vector_t *strvec)
 {
-	virtual_server *vs = LIST_TAIL_DATA(check_data->vs);
+	virtual_server_t *vs = LIST_TAIL_DATA(check_data->vs);
 	if (vs->addr.ss_family == AF_INET6)
 		vs->granularity_persistence = atoi(vector_slot(strvec, 1));
 	else
@@ -140,20 +140,20 @@ pgr_handler(vector_t *strvec)
 static void
 proto_handler(vector_t *strvec)
 {
-	virtual_server *vs = LIST_TAIL_DATA(check_data->vs);
+	virtual_server_t *vs = LIST_TAIL_DATA(check_data->vs);
 	char *str = vector_slot(strvec, 1);
 	vs->service_type = (!strcmp(str, "TCP")) ? IPPROTO_TCP : IPPROTO_UDP;
 }
 static void
 hasuspend_handler(vector_t *strvec)
 {
-	virtual_server *vs = LIST_TAIL_DATA(check_data->vs);
+	virtual_server_t *vs = LIST_TAIL_DATA(check_data->vs);
 	vs->ha_suspend = 1;
 }
 static void
 virtualhost_handler(vector_t *strvec)
 {
-	virtual_server *vs = LIST_TAIL_DATA(check_data->vs);
+	virtual_server_t *vs = LIST_TAIL_DATA(check_data->vs);
 	vs->virtualhost = set_value(strvec);
 }
 
@@ -173,8 +173,8 @@ rs_handler(vector_t *strvec)
 static void
 weight_handler(vector_t *strvec)
 {
-	virtual_server *vs = LIST_TAIL_DATA(check_data->vs);
-	real_server *rs = LIST_TAIL_DATA(vs->rs);
+	virtual_server_t *vs = LIST_TAIL_DATA(check_data->vs);
+	real_server_t *rs = LIST_TAIL_DATA(vs->rs);
 	rs->weight = atoi(vector_slot(strvec, 1));
 	rs->iweight = rs->weight;
 }
@@ -182,68 +182,68 @@ weight_handler(vector_t *strvec)
 static void
 uthreshold_handler(vector_t *strvec)
 {
-	virtual_server *vs = LIST_TAIL_DATA(check_data->vs);
-	real_server *rs = LIST_TAIL_DATA(vs->rs);
+	virtual_server_t *vs = LIST_TAIL_DATA(check_data->vs);
+	real_server_t *rs = LIST_TAIL_DATA(vs->rs);
 	rs->u_threshold = atoi(vector_slot(strvec, 1));
 }
 static void
 lthreshold_handler(vector_t *strvec)
 {
-	virtual_server *vs = LIST_TAIL_DATA(check_data->vs);
-	real_server *rs = LIST_TAIL_DATA(vs->rs);
+	virtual_server_t *vs = LIST_TAIL_DATA(check_data->vs);
+	real_server_t *rs = LIST_TAIL_DATA(vs->rs);
 	rs->l_threshold = atoi(vector_slot(strvec, 1));
 }
 #endif
 static void
 inhibit_handler(vector_t *strvec)
 {
-	virtual_server *vs = LIST_TAIL_DATA(check_data->vs);
-	real_server *rs = LIST_TAIL_DATA(vs->rs);
+	virtual_server_t *vs = LIST_TAIL_DATA(check_data->vs);
+	real_server_t *rs = LIST_TAIL_DATA(vs->rs);
 	rs->inhibit = 1;
 }
 static void
 notify_up_handler(vector_t *strvec)
 {
-	virtual_server *vs = LIST_TAIL_DATA(check_data->vs);
-	real_server *rs = LIST_TAIL_DATA(vs->rs);
+	virtual_server_t *vs = LIST_TAIL_DATA(check_data->vs);
+	real_server_t *rs = LIST_TAIL_DATA(vs->rs);
 	rs->notify_up = set_value(strvec);
 }
 static void
 notify_down_handler(vector_t *strvec)
 {
-	virtual_server *vs = LIST_TAIL_DATA(check_data->vs);
-	real_server *rs = LIST_TAIL_DATA(vs->rs);
+	virtual_server_t *vs = LIST_TAIL_DATA(check_data->vs);
+	real_server_t *rs = LIST_TAIL_DATA(vs->rs);
 	rs->notify_down = set_value(strvec);
 }
 static void
 alpha_handler(vector_t *strvec)
 {
-	virtual_server *vs = LIST_TAIL_DATA(check_data->vs);
+	virtual_server_t *vs = LIST_TAIL_DATA(check_data->vs);
 	vs->alpha = 1;
 	vs->quorum_state = DOWN;
 }
 static void
 omega_handler(vector_t *strvec)
 {
-	virtual_server *vs = LIST_TAIL_DATA(check_data->vs);
+	virtual_server_t *vs = LIST_TAIL_DATA(check_data->vs);
 	vs->omega = 1;
 }
 static void
 quorum_up_handler(vector_t *strvec)
 {
-	virtual_server *vs = LIST_TAIL_DATA(check_data->vs);
+	virtual_server_t *vs = LIST_TAIL_DATA(check_data->vs);
 	vs->quorum_up = set_value(strvec);
 }
 static void
 quorum_down_handler(vector_t *strvec)
 {
-	virtual_server *vs = LIST_TAIL_DATA(check_data->vs);
+	virtual_server_t *vs = LIST_TAIL_DATA(check_data->vs);
 	vs->quorum_down = set_value(strvec);
 }
 static void
 quorum_handler(vector_t *strvec)
 {
-	virtual_server *vs = LIST_TAIL_DATA(check_data->vs);
+	virtual_server_t *vs = LIST_TAIL_DATA(check_data->vs);
 	long tmp = atol (vector_slot(strvec, 1));
 	if (tmp < 1) {
 		log_message(LOG_ERR, "Condition not met: Quorum >= 1");
@@ -256,7 +256,7 @@ quorum_handler(vector_t *strvec)
 static void
 hysteresis_handler(vector_t *strvec)
 {
-	virtual_server *vs = LIST_TAIL_DATA(check_data->vs);
+	virtual_server_t *vs = LIST_TAIL_DATA(check_data->vs);
 	long tmp = atol (vector_slot(strvec, 1));
 	if (tmp < 0 || tmp >= vs->quorum) {
 		log_message(LOG_ERR, "Condition not met: 0 <= Hysteresis <= Quorum - 1");
diff -rupN keepalived-1.2.7/keepalived/check/check_snmp.c keepalived-1.2.7-unicast/keepalived/check/check_snmp.c
--- keepalived-1.2.7/keepalived/check/check_snmp.c	2012-08-29 00:05:12.000000000 +0200
+++ keepalived-1.2.7-unicast/keepalived/check/check_snmp.c	2013-05-24 10:12:36.514161800 +0200
@@ -31,9 +31,9 @@ static u_char*
 check_snmp_vsgroup(struct variable *vp, oid *name, size_t *length,
 		   int exact, size_t *var_len, WriteMethod **write_method)
 {
-	virtual_server_group *g;
+	virtual_server_group_t *g;
 
-	if ((g = (virtual_server_group *)
+	if ((g = (virtual_server_group_t *)
 	     snmp_header_list_table(vp, name, length, exact,
 				    var_len, write_method,
 				    check_data->vs_group)) == NULL)
@@ -60,8 +60,8 @@ check_snmp_vsgroupmember(struct variable
         int result, target_len;
 	int curgroup = 0, curentry;
 	element e1, e2;
-	virtual_server_group *group;
-	virtual_server_group_entry *e, *be = NULL;
+	virtual_server_group_t *group;
+	virtual_server_group_entry_t *e, *be = NULL;
 	int state;
 	list l;
 
@@ -212,10 +212,10 @@ check_snmp_virtualserver(struct variable
 #ifdef _KRNL_2_6_
 	static U64 counter64_ret;
 #endif
-	virtual_server *v;
+	virtual_server_t *v;
 	element e;
 
-	if ((v = (virtual_server *)
+	if ((v = (virtual_server_t *)
 	     snmp_header_list_table(vp, name, length, exact,
 				    var_len, write_method,
 				    check_data->vs)) == NULL)
@@ -366,7 +366,7 @@ check_snmp_virtualserver(struct variable
 		long_ret = 0;
 		if (!LIST_ISEMPTY(v->rs))
 			for (e = LIST_HEAD(v->rs); e; ELEMENT_NEXT(e))
-				if (((real_server *)ELEMENT_DATA(e))->alive)
+				if (((real_server_t *)ELEMENT_DATA(e))->alive)
 					long_ret++;
 		return (u_char*)&long_ret;
 #if defined(_KRNL_2_6_) && defined(_WITH_LVS_)
@@ -430,8 +430,8 @@ check_snmp_realserver_weight(int action,
 			     u_char *statP, oid *name, size_t name_len)
 {
 	element e1, e2;
-	virtual_server *vs = NULL;
-	real_server *rs = NULL;
+	virtual_server_t *vs = NULL;
+	real_server_t *rs = NULL;
 	int ivs, irs;
 	switch (action) {
 	case RESERVE1:
@@ -490,9 +490,9 @@ check_snmp_realserver(struct variable *v
         oid *target, current[2], best[2];
         int result, target_len;
 	int curvirtual = 0, curreal;
-	real_server *e = NULL, *be = NULL;
+	real_server_t *e = NULL, *be = NULL;
 	element e1, e2 = NULL;
-	virtual_server *vs, *bvs = NULL;
+	virtual_server_t *vs, *bvs = NULL;
 	int state;
 	int type, btype;
 
@@ -882,7 +882,7 @@ check_snmp_agent_close()
 }
 
 void
-check_snmp_rs_trap(real_server *rs, virtual_server *vs)
+check_snmp_rs_trap(real_server_t *rs, virtual_server_t *vs)
 {
 	element e;
 
@@ -953,7 +953,7 @@ check_snmp_rs_trap(real_server *rs, virt
 	realup = 0;
 	if (!LIST_ISEMPTY(vs->rs))
 		for (e = LIST_HEAD(vs->rs); e; ELEMENT_NEXT(e))
-			if (((real_server *)ELEMENT_DATA(e))->alive)
+			if (((real_server_t *)ELEMENT_DATA(e))->alive)
 				realup++;
 
 	/* snmpTrapOID */
@@ -1084,7 +1084,7 @@ check_snmp_rs_trap(real_server *rs, virt
 }
 
 void
-check_snmp_quorum_trap(virtual_server *vs)
+check_snmp_quorum_trap(virtual_server_t *vs)
 {
 	check_snmp_rs_trap(NULL, vs);
 }
diff -rupN keepalived-1.2.7/keepalived/check/check_ssl.c keepalived-1.2.7-unicast/keepalived/check/check_ssl.c
--- keepalived-1.2.7/keepalived/check/check_ssl.c	2012-08-29 00:05:12.000000000 +0200
+++ keepalived-1.2.7-unicast/keepalived/check/check_ssl.c	2013-05-24 10:12:36.516162000 +0200
@@ -192,8 +192,8 @@ ssl_connect(thread_t * thread, int new_r
 {
 	checker_t *checker = THREAD_ARG(thread);
 	http_checker_t *http_get_check = CHECKER_ARG(checker);
-	http_arg_t *http_arg = HTTP_ARG(http_get_check);
-	request_t *req = HTTP_REQ(http_arg);
+	http_t *http = HTTP_ARG(http_get_check);
+	request_t *req = HTTP_REQ(http);
 	int ret = 0;
 	int val = 0;
 
@@ -242,8 +242,8 @@ ssl_read_thread(thread_t * thread)
 {
 	checker_t *checker = THREAD_ARG(thread);
 	http_checker_t *http_get_check = CHECKER_ARG(checker);
-	http_arg_t *http_arg = HTTP_ARG(http_get_check);
-	request_t *req = HTTP_REQ(http_arg);
+	http_t *http = HTTP_ARG(http_get_check);
+	request_t *req = HTTP_REQ(http);
 	unsigned char digest[16];
 	int r = 0;
 	int val;
